// Board.cpp : implementation file
//

#include "stdafx.h"
#include "Board.h"
#include <olerrors.h>
#include <oltypes.h>
#include <olxdaapi.h>
#include <olxdadefs.h>
#include "contdispDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBoard dialog


CBoard::CBoard(CWnd* pParent /*=NULL*/)
	: CDialog(CBoard::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBoard)
	m_strBoardName = _T("");
	//}}AFX_DATA_INIT
	CContdispDlg *pDlg = (CContdispDlg*)pParent;

	if(pDlg != NULL)
		m_pADC = &(pDlg->m_ADC);


}


void CBoard::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBoard)
	DDX_Control(pDX, IDC_BOARD, m_cboBoard);
	DDX_CBString(pDX, IDC_BOARD, m_strBoardName);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CBoard, CDialog)
	//{{AFX_MSG_MAP(CBoard)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBoard message handlers

void CBoard::OnOK() 
{
	ECODE ecode = OLNOERROR;
	UINT numDMAChans = 0,support = FALSE;

	CDialog::OnOK();

	if(!m_strBoardName.IsEmpty())
	{
		try
		{
		m_pADC->SetBoard(m_strBoardName);
		m_pADC->SetSubSysType(OLSS_AD);
		m_pADC->SetSubSysElement(0);
		}
		catch(COleDispatchException* e)
		{
			e->Delete();
			EndDialog(IDOK);
			return;

		}

	}
	else EndDialog(IDCANCEL);

}

void CBoard::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	CDialog::OnCancel();
}

BOOL CBoard::OnInitDialog() 
{
	UINT x=0,uiNumBoards = 0;

	CDialog::OnInitDialog();

	m_strBoardName = m_pADC->GetBoard();  // set to controls current board

	// fill combo box with available DT-Open Layers devices
	m_cboBoard.ResetContent();
	uiNumBoards = m_pADC->GetNumBoards();
	for(x=0; x < uiNumBoards; x++)
	{
		m_cboBoard.AddString(m_pADC->GetBoardList(x));
	}
	m_cboBoard.SelectString(0,m_strBoardName);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
