// contdispDlg.cpp : implementation file
//

#include "stdafx.h"
#include "contdisp.h"
#include "contdispDlg.h"
#include "board.h"

#include <math.h>
#include <oltypes.h>
#include <olerrors.h>
#include <olmem.h>
#include <olxdadefs.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define SAMPFREQ 400
#define BUFFSIZE 200
#define NUMBUFFS 4
#define LIGHT_BLUE	   0x00ffff00
#define BLUE 0x00ff0000
#define LIGHT_MAGENTA	0x00ff00ff
#define LIGHT_GREEN		0x0000ff00
#define WHITE	0x00ffffff

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CContdispDlg dialog

CContdispDlg::CContdispDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CContdispDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CContdispDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CContdispDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CContdispDlg)
	DDX_Control(pDX, IDC_STOP, m_btnStop);
	DDX_Control(pDX, IDC_START, m_btnStart);
	DDX_Control(pDX, IDC_ADC, m_ADC);
	DDX_Control(pDX, IDC_PLOT1, m_Plot1);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CContdispDlg, CDialog)
	//{{AFX_MSG_MAP(CContdispDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_START, OnStart)
	ON_BN_CLICKED(IDC_STOP, OnStop)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CContdispDlg message handlers

BOOL CContdispDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	CString strAboutMenu;
	strAboutMenu.LoadString(IDS_ABOUTBOX);
	if (!strAboutMenu.IsEmpty())
	{
		pSysMenu->AppendMenu(MF_SEPARATOR);
		pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	int x;
	HBUF hBuf;
	ECODE ecode;

	if(m_ADC.GetHDass() == NULL)
	{
		CBoard dlgBoard(this);

		if(dlgBoard.DoModal() != IDOK)
		{
			EndDialog(IDCANCEL);
			return TRUE;
		}
	}
	if(m_ADC.GetHDass() == NULL)
	{
		AfxMessageBox("Board/Subsystem is not available.");
		EndDialog(IDCANCEL);
		return TRUE;
	}
	m_ADC.SetDataFlow(OLx_DF_CONTINUOUS); // continuous data flow
	m_ADC.SetWrapMode(OLx_WRP_NONE); // no buffer wrapping
	m_ADC.SetFrequency(SAMPFREQ);
	if(m_ADC.GetSSCaps(OLSSC_NUMDMACHANS) > 0)
		m_ADC.SetDmaUsage(1);
	else
		m_ADC.SetDmaUsage(0);

	m_ADC.SetChannelList(0,0);
	m_Plot1.SetPalette(0,BLUE);
	m_Plot1.SetBackColor(WHITE);

	//Is A/D a simulataneous Sample & Hold ?
	if(m_ADC.GetSSCaps(OLSSC_SUP_SIMULTANEOUS_SH) == TRUE) 
	{
			m_ADC.SetListSize(2);
			m_ADC.SetChannelList(0,0);
			m_ADC.SetChannelList(1,1);
			m_Plot1.SetPalette(1,LIGHT_MAGENTA);
	}
	else	m_ADC.SetListSize(1);

	// allocate buffers and put onto ready queue
	for(x=0;x<NUMBUFFS;x++)
	{
		ecode = olDmAllocBuffer(0,BUFFSIZE*m_ADC.GetListSize(),&hBuf);
		if((ecode == OLNOERROR)&&(hBuf != NULL))
		{
			m_ADC.SetQueue((long)hBuf); // but buffer onto Ready queue
		}
	}

	// set plot labels

	m_Plot1.SetDataType(m_ADC.GetEncoding());
	m_Plot1.SetNumChannels((short)m_ADC.GetListSize());

	// set up graph scaling
	m_Plot1.SetXStart(0.F);
	m_Plot1.SetXLength((float)BUFFSIZE);
	if(m_ADC.GetEncoding() == OLx_ENC_2SCOMP)
	{
		m_Plot1.SetYMax((float)(pow(2,(m_ADC.GetResolution() - 1)) - 1));
		m_Plot1.SetYMin(0 - m_Plot1.GetYMax());
	}
	else
	{
		m_Plot1.SetYMax((float)(pow(2,m_ADC.GetResolution()) - 1));
		m_Plot1.SetYMin(0.F);
	}

	// set up plot grids
	m_Plot1.SetGridColor(LIGHT_GREEN);
	m_Plot1.SetGridXStart((float)(BUFFSIZE/10));
	m_Plot1.SetGridXSpacing((float)(BUFFSIZE /10));
	m_Plot1.SetGridXOn(TRUE);
	m_Plot1.SetGridYStart(((m_Plot1.GetYMax() - m_Plot1.GetYMin()) /8) + 1);
	m_Plot1.SetGridYSpacing((m_Plot1.GetYMax() - m_Plot1.GetYMin()) / 8);
	m_Plot1.SetGridYOn(TRUE);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CContdispDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CContdispDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CContdispDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

BEGIN_EVENTSINK_MAP(CContdispDlg, CDialog)
    //{{AFX_EVENTSINK_MAP(CContdispDlg)
	ON_EVENT(CContdispDlg, IDC_ADC, 1 /* BufferDone */, OnBufferDoneAdc, VTS_NONE)
	ON_EVENT(CContdispDlg, IDC_ADC, 2 /* QueueDone */, OnQueueDoneAdc, VTS_NONE)
	ON_EVENT(CContdispDlg, IDC_ADC, 4 /* TriggerError */, OnTriggerErrorAdc, VTS_NONE)
	ON_EVENT(CContdispDlg, IDC_ADC, 5 /* OverrunError */, OnOverrunErrorAdc, VTS_NONE)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void CContdispDlg::OnStart() 
{
	m_ADC.ClearError();
	m_ADC.Config();
	m_ADC.Start();

	m_btnStart.EnableWindow(FALSE);
	m_btnStop.EnableWindow(TRUE);


	
}

void CContdispDlg::OnStop() 
{
	HBUF hBuf;

	m_ADC.Abort();
	m_ADC.Flush(); // flush all buffers to done queue
	do
	{
		hBuf = (HBUF)m_ADC.GetQueue();			
		if(hBuf != NULL)	m_ADC.SetQueue((long)hBuf);
	}while(hBuf != NULL);

	m_btnStart.EnableWindow(TRUE);
	m_btnStop.EnableWindow(FALSE);
}

void CContdispDlg::OnBufferDoneAdc() 
{
	HBUF hBuf;

	// graph data & then recycle buffer
	hBuf = (HBUF)m_ADC.GetQueue();
	if(hBuf == NULL) return;

	m_Plot1.SetBuffer((long)hBuf);			//RAS
	m_ADC.SetQueue((long)hBuf);				//RAS
}

void CContdispDlg::OnQueueDoneAdc() 
{
	OnStop();
	AfxMessageBox("Acquisition stopped, rate too fast for current operations");
}

void CContdispDlg::OnTriggerErrorAdc() 
{
	AfxMessageBox("A/D Trigger Error!!!");
	m_btnStart.EnableWindow(TRUE);
	m_btnStop.EnableWindow(FALSE);
}

void CContdispDlg::OnOverrunErrorAdc() 
{
	AfxMessageBox("A/D Overrun Error !!!");
	m_btnStart.EnableWindow(TRUE);
	m_btnStop.EnableWindow(FALSE);
}

BOOL CContdispDlg::DestroyWindow() 
{
	HBUF hBuf;
	ECODE ecode;

	if(m_ADC.GetHDass() != NULL)
	{
		// clean up
		m_ADC.Flush(); // flush all buffers to done queue

		do
		{
			hBuf = (HBUF)m_ADC.GetQueue();
			if(hBuf != NULL)
			{
				ecode = olDmFreeBuffer(hBuf);
				if(ecode != OLNOERROR)
					AfxMessageBox("Error Freeing Buffer");
			}
		}while(hBuf != NULL);
	}	
	return CDialog::DestroyWindow();
}
